            SafeFire PPP 1.1
            Additions library
           Shaper module alpha
          (c) Link Guard Solutions

    New plugin library name pl_add contains two plugins that must be used to perform traffic shaping.
    This plugins can be used to limit traffic flow using single (plugin name "SINGLESHAPER") or multiple (plugin name "SHAPER") virtual channels with fixed speed.
    Plugin SINGLESHAPER is less resource consuming then SHAPER, but has no "single" option and works as if this option is turned ON.
    Plugin has two Stream Packs - IN and OUT, that works in multistream mode (even for SINGLESHAPER), please see "single" parameter description (and remember that SINGLESHAPER acts as if this parameter is ON).
    Plugin knows next parameters:
        timeout     - time (seconds) - delay before single retry of packet sending if limit is exausted. Default value is 0 - do not wait, but drop packet if limit is exausted.
        single      - boolean (default no) - SHAPER plugin only. If to use single virtual channel for all streams of the stream pack. By default every index has it's own virtual channel.
        rate        - integer (byte per second) (default 100) - average flow limit for every virtual channel
        limit       - integer (bytes) (default 500) - peak flow limit. Must be higher then rate
        bothsided   - boolean (defaul yes) - if to limit both directions (in/out). In no - limit only for packets from IN to OUT. Note: If bothsided=yes, rate and limit options defined limit for flow both from IN _and_ OUT _summed_. If you want to have different limits for IN->OUT and OUT->IN directions, please use bothsided=no and two virtual channels.

    To get information on how to limit by attribute (i.e. by source IP or Port Number), please see fw_pipe.txt


